/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
// globals
var updateTimer;
var updateInterval = 120*1000;
var preferenceKey = "ipsensors";
var ip_address="";

function load()
{
   dashcode.setupParts();
   loadPrefs();    
   startTimer(updateInterval);
   
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    stopTimer();    
    savePrefs();

}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    alert("hide!");
    stopTimer();    
    savePrefs();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    //startTimer(updateInterval);
    alert("show!");
    loadPrefs();    
    //execStatsRequest();
    startTimer(updateInterval);

}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    //
    stopTimer();    
    alert("showBack!");
    }

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";
   if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    //
    alert("showFront!");
    alert("newip=");
    ip_address=document.getElementById("ipSensors").value;
    alert(document.getElementById("ipSensors").value);
    savePrefs();    
    //loadPrefs();    
    execStatsRequest();
    startTimer(updateInterval);

}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

///// **************
///// мои функции
function startTimer(msec)
{
    updateTimer = setTimeout("updateStats()", msec);
}

function stopTimer()
{
    clearTimeout(updateTimer);
}

function updateStats()
{
    alert("It works!");
    execStatsRequest();
    startTimer(updateInterval);
} 

function execStatsRequest()
{
        //var Url = "http://77.39.66.172:10001";
        var Url = "http://"+ip_address;
        alert("Url= " + Url);

        xmlHttp = new XMLHttpRequest(); 
        xmlHttp.onreadystatechange = processStatsRequest;
        xmlHttp.overrideMimeType('application/json');
        xmlHttp.open("GET", Url, true);
        xmlHttp.send();

}

function processStatsRequest() 
{
     if (xmlHttp.readyState == 4 && xmlHttp.status == 200)
    {
      alert(xmlHttp.responseText);
      try  
        {
        var data = JSON.parse(xmlHttp.responseText);
        document.getElementById("valT1").innerText =data.meteo.temp1;
        document.getElementById("valT2").innerText =data.meteo.temp3;
        document.getElementById("valH").innerText =data.meteo.humidity4;
        document.getElementById("valP").innerText =data.meteo.pressure5;
        //setParams(1,data.meteo.temp1);
        //setParams(2,data.meteo.temp3);
        //setParams(3,data.meteo.humidity4);        
        //setParams(4,data.meteo.pressure5);
        //
        var datenow=new Date();
        var strdatetime=(datenow.getHours()<10) ? ("0"+datenow.getHours().toString()) :(datenow.getHours().toString());
        strdatetime+=":";
        strdatetime+=(datenow.getMinutes()<10) ? ("0"+datenow.getMinutes().toString()) :(datenow.getMinutes().toString());
        strdatetime+=":";
        strdatetime+=(datenow.getSeconds()<10) ? ("0"+datenow.getSeconds().toString()) :(datenow.getSeconds().toString());
        strdatetime+=" ";
        strdatetime+=(datenow.getDate()<10) ? ("0"+datenow.getDate().toString()) :(datenow.getDate().toString());
        strdatetime+="-";
        strdatetime+=(datenow.getMonth()<9) ? ("0"+(datenow.getMonth()+1).toString()) :((datenow.getMonth()+1).toString());
        strdatetime+="-";
        strdatetime+=""+(datenow.getYear()+1900).toString()+"";
        document.getElementById("timeDay").innerText=strdatetime; 
        savePrefs();
        }
      catch(e)
        {
        alert("error");
        }
    }
 }
 
 function setParams(nparam,value1)
{
;
}
// 
function loadPrefs()
{
    var ip = widget.preferenceForKey("weatheripsensors");
    alert(widget.identifier + "-" + preferenceKey);
    alert("ip address preferences: " + ip);
    ip_address=ip;
    document.getElementById("ipSensors").value=ip;
    var t1=widget.preferenceForKey("weathertemp1");
    document.getElementById("valT1").innerText=t1;
    var t2=widget.preferenceForKey("weathertemp2");
    document.getElementById("valT2").innerText=t2;
    var h=widget.preferenceForKey("weatherh");
    document.getElementById("valH").innerText=h;
    var p=widget.preferenceForKey("weatherp");
    document.getElementById("valP").innerText=p;
    var timeDay=widget.preferenceForKey("weathertimeday");
    document.getElementById("timeDay").innerText=timeDay;
    }

function savePrefs()
{   alert("save=");
    widget.setPreferenceForKey(document.getElementById("ipSensors").value, "weatheripsensors");       
    alert(document.getElementById("ipSensors").value);
    widget.setPreferenceForKey(document.getElementById("valT1").innerText, "weathertemp1");      
    alert(document.getElementById("valT1").innerText);
    widget.setPreferenceForKey(document.getElementById("valT2").innerText, "weathertemp2");      
    alert(document.getElementById("valT2").innerText);
    widget.setPreferenceForKey(document.getElementById("valH").innerText, "weatherh");      
    alert(document.getElementById("valH").innerText);
    widget.setPreferenceForKey(document.getElementById("valP").innerText, "weatherp");      
    alert(document.getElementById("valP").innerText);
    widget.setPreferenceForKey(document.getElementById("timeDay").innerText, "weathertimeday");      
    alert(document.getElementById("timeDay").innerText);
    
}


